
{ Demo for SPI Slave
  Tested on Activity Board with I/O 10 connected to I/O 0
  and I/O 11 connected to I/O 1}
CON
        _clkmode = xtal1 + pll16x    'Standard clock mode 
        _xinfreq = 5_000_000         '* crystal frequency = 80 MHz

        SPI_Clock = 0, SPI_Data = 1  'clock and data for slave receiver
        outclk = 10, outdata=11      'clock and data for master transmitter    
        
VAR
  long  XmitData            'data send by demo program
  long  RcvData             'data received by machine cog
  byte  BitCount            'number of bits
  byte  example             'will demo several examples             '
  
OBJ
  pst      : "parallax serial terminal"
  sps      : "SPI Slave"
  
PUB main
    pst.Start (115_200)                    'start up ser terminal
    pst.str(String("hello, world   "))     'runs in cog 1
    pst.NewLine
    waitcnt(clkfreq/10 + cnt)

    dira[outclk]~~
    dira[outdata]~~

    example := sps.start
    pst.str(string("Started SPS Cog.  Cog Number: "))
    pst.dec(example)
    pst.newline

    repeat example from 0 to 6
      BitCount := lookupz(example: 32, 16, 8, 32, 24, 16, 8)
      sps.arm(SPI_Clock, SPI_Data, BitCount)
      XMitData := lookupz(example: $12345678, $FFFFABCD, $55551942, $DEADBEEF, $DEADBEEF, $DEADBEEF, $DEADBEEF) 
      SendPat(BitCount, XmitData)       'transmit a pattern
      RcvData := sps.wait               'wait for completion, get results
      
      pst.str(string("Example: "))      'display it all
      pst.hex(example, 1)
      pst.str(string("  Bit Count: "))
      pst.dec(BitCount)
      pst.str(string("  Transmitted: "))
      pst.hex(XmitData, BitCount/4)
      pst.str(string("  Received: "))
      pst.hex(RcvData, 8)
      pst.newline
      
    sps.stop
    pst.str(string("Stopped SPS Cog"))
    pst.newline
    pst.newline
    waitcnt(clkfreq+cnt)

pub SendPat(count, data) | point
     outa[outclk]~
     repeat point from count-1 to 0
       outa[outdata] := (data >> point) & $1
       outa[outclk]~~
       outa[outclk]~       

               
          


                                                                            