
{SPI Slave}
CON
        _clkmode = xtal1 + pll16x    'Standard clock mode 
        _xinfreq = 5_000_000         '* crystal frequency = 80 MHz
        
VAR      
  long  Command                     '<> 0 says => start up receiver
                                       '31..24:  Clock Pin
                                       '23..16:  Data Pin
                                       '15..0:   Number of bits (up to 32)

  long rcvData                         'what was returned from machine cog                              
  byte  Cog                            'used to stop cog if needful
  long  MyParm[2]                      'parameters to machine cog
  
PUB start                              'start the PASM cog. no parameters
    myParm[0] := @command              'give addresses to PASM cog
    myParm[1] := @RcvData
    cog := cognew(@SPSCog, @MyParm)    'start the cog       
    return cog                         'return the cog number

PUB stop                               'unconditionally kill the PASM cog 
    cogstop(cog)                       'make the cog available

PUB arm(clockpin, datapin, count)      'I/O numbers and bit count   
    Command := (clockpin << 24) | (datapin << 16) | count   
    return

PUB wait                                'wait here until data are available
    repeat while command <> 0
    return RcvData         
          
DAT
SPSCog  org   0                'SPI Slave Receiver
        mov AdPar,Par          'get the address of the parameter list
        rdlong AdCommand, AdPar 'address of the command word
        add AdPar, #4
        rdlong AdResult, AdPar 'and the address where to return the result
                
'*********************wait here for something to do*************************                                                   
top     rdlong MyCommand, AdCommand wz  'wait for a command
        if_Z jmp #top                   'just hang here
        rdlong MyCommand, AdCommand     'get the command
        mov Work1, MyCommand
        shr Work1, #24                  'normalize the clock pin number
        and Work1, #$1F                 'keep just pin number
        mov ClkMask, #1                 'form a mask with a single "one"
        shl ClkMask, Work1              'corresponding to clock pin
        mov Work1, MyCommand            'exactly the same for data pin
        shr Work1, #16
        and Work1, #$1F
        mov DatMask, #1
        shl DatMask, Work1
        and MyCommand, #$3f             'now isolate the bit count
        mov BitCnt, #32                 'up to 32 bits
        sub BitCnt, MyCommand           'distance to jump into receivers
        shl BitCnt, #2                  'at four instructions per
        add BitCnt, JTab                'build jump instruction
        mov MyJump, BitCnt
        mov DLong, #0                   'start with all balls        
MyJump  jmp #ReC                          'into receive list

ReC     waitpeq clkmask, ClkMask        'wait for clock to go high
        test DatMask, ina wz            'see if bit set
        if_NZ OR DLong, Powers2 + 0     'high order bit 
        waitpeq Zero, ClkMask           'wait for clock low
        
        waitpeq ClkMask, ClkMask        'now the same for bit 30
        test DatMask, ina wz        
        if_NZ OR DLong, Powers2 + 1
        waitpeq Zero, ClkMask
        
        waitpeq ClkMask, ClkMask        'and so on
        test DatMask, ina wz        
        if_NZ OR DLong, Powers2 + 2
        waitpeq Zero, ClkMask 
        
        waitpeq ClkMask, ClkMask        'and so on
        test DatMask, ina wz        
        if_NZ OR DLong, Powers2 + 3
        waitpeq Zero, ClkMask
        
        waitpeq ClkMask, ClkMask        'and so on
        test DatMask, ina wz        
        if_NZ OR DLong, Powers2 + 4
        waitpeq Zero, ClkMask

        waitpeq ClkMask, ClkMask        'and so on
        test DatMask, ina wz        
        if_NZ OR DLong, Powers2 + 5
        waitpeq Zero, ClkMask

        waitpeq ClkMask, ClkMask        'and so on
        test DatMask, ina wz        
        if_NZ OR DLong, Powers2 + 6
        waitpeq Zero, ClkMask

        waitpeq ClkMask, ClkMask        'and so on
        test DatMask, ina wz        
        if_NZ OR DLong, Powers2 + 7
        waitpeq Zero, ClkMask

        waitpeq ClkMask, ClkMask        'and so on
        test DatMask, ina wz        
        if_NZ OR DLong, Powers2 + 8
        waitpeq Zero, ClkMask

        waitpeq ClkMask, ClkMask        'and so on
        test DatMask, ina wz        
        if_NZ OR DLong, Powers2 + 9
        waitpeq Zero, ClkMask

        waitpeq ClkMask, ClkMask        'and so on
        test DatMask, ina wz        
        if_NZ OR DLong, Powers2 + 10
        waitpeq Zero, ClkMask

        waitpeq ClkMask, ClkMask        'and so on
        test DatMask, ina wz        
        if_NZ OR DLong, Powers2 + 11
        waitpeq Zero, ClkMask

        waitpeq ClkMask, ClkMask        'and so on
        test DatMask, ina wz        
        if_NZ OR DLong, Powers2 + 12
        waitpeq Zero, ClkMask

        waitpeq ClkMask, ClkMask        'and so on
        test DatMask, ina wz        
        if_NZ OR DLong, Powers2 + 13
        waitpeq Zero, ClkMask

        waitpeq ClkMask, ClkMask        'and so on
        test DatMask, ina wz        
        if_NZ OR DLong, Powers2 + 14
        waitpeq Zero, ClkMask

        waitpeq ClkMask, ClkMask        'and so on
        test DatMask, ina wz        
        if_NZ OR DLong, Powers2 + 15
        waitpeq Zero, ClkMask

        waitpeq ClkMask, ClkMask        'and so on
        test DatMask, ina wz        
        if_NZ OR DLong, Powers2 + 16
        waitpeq Zero, ClkMask

        waitpeq ClkMask, ClkMask        'and so on
        test DatMask, ina wz        
        if_NZ OR DLong, Powers2 + 17
        waitpeq Zero, ClkMask

        waitpeq ClkMask, ClkMask        'and so on
        test DatMask, ina wz        
        if_NZ OR DLong, Powers2 + 18
        waitpeq Zero, ClkMask

        waitpeq ClkMask, ClkMask        'and so on
        test DatMask, ina wz        
        if_NZ OR DLong, Powers2 + 19
        waitpeq Zero, ClkMask

        waitpeq ClkMask, ClkMask        'and so on
        test DatMask, ina wz        
        if_NZ OR DLong, Powers2 + 20
        waitpeq Zero, ClkMask

        waitpeq ClkMask, ClkMask        'and so on
        test DatMask, ina wz        
        if_NZ OR DLong, Powers2 + 21
        waitpeq Zero, ClkMask

        waitpeq ClkMask, ClkMask        'and so on
        test DatMask, ina wz        
        if_NZ OR DLong, Powers2 + 22
        waitpeq Zero, ClkMask

        waitpeq ClkMask, ClkMask        'and so on
        test DatMask, ina wz        
        if_NZ OR DLong, Powers2 + 23
        waitpeq Zero, ClkMask

        waitpeq ClkMask, ClkMask        'and so on
        test DatMask, ina wz        
        if_NZ OR DLong, Powers2 + 24
        waitpeq Zero, ClkMask

        waitpeq ClkMask, ClkMask        'and so on
        test DatMask, ina wz        
        if_NZ OR DLong, Powers2 + 25
        waitpeq Zero, ClkMask

        waitpeq ClkMask, ClkMask        'and so on
        test DatMask, ina wz        
        if_NZ OR DLong, Powers2 + 26
        waitpeq Zero, ClkMask

        waitpeq ClkMask, ClkMask        'and so on
        test DatMask, ina wz        
        if_NZ OR DLong, Powers2 + 27
        waitpeq Zero, ClkMask

        waitpeq ClkMask, ClkMask        'and so on
        test DatMask, ina wz        
        if_NZ OR DLong, Powers2 + 28
        waitpeq Zero, ClkMask

        waitpeq ClkMask, ClkMask        'and so on
        test DatMask, ina wz        
        if_NZ OR DLong, Powers2 + 29
        waitpeq Zero, ClkMask

        waitpeq ClkMask, ClkMask        'and so on
        test DatMask, ina wz        
        if_NZ OR DLong, Powers2 + 30
        waitpeq Zero, ClkMask
  
        waitpeq ClkMask, ClkMask        'and so on
        test DatMask, ina wz        
        if_NZ OR DLong, Powers2 + 31    'all the way to low-order bit
        waitpeq Zero, ClkMask
        
release wrlong DLong, AdResult         'store the result
        wrlong Zero, AdCommand         'say we're all done
        jmp #top  
        
                         '                  
zero        long 0                   'constants
JTab        jmp #ReC                 'fresh copy of jump into receive list 
Powers2     long  $8000_0000, $4000_0000, $2000_0000, $1000_0000  'powers of 2
            long  $800_0000, $400_0000, $200_0000, $100_0000
            long  $80_0000, $40_0000, $20_0000, $10_0000
            long  $8_0000, $4_0000, $2_0000, $1_0000
            long  $8000, $4000, $2000, $1000, $800, $400, $200, $100
            long  $80, $40, $20, $10, $8, $4, $2, $1
             
ClkMask     res  1                   'mask corresponding to clock pin
DatMask     res  1                   'mask corresponding to data pin
AdCommand   res  1                   'address of command long
MyCommand   res  1                   'my copy
AdPar       res  1                   'address of parameter list
AdResult    res  1                   'where to return the result to
Work1       res  1                   'generally useful
DLong       res  1                   'variable being received
BitCnt      res  1                   'number of bits to receive
                                                                            